import { ModuleMetadata, Type } from '@nestjs/common/interfaces';
export interface AccessTokenInfo {
    getTime: number;
    expiresIn: number;
    accessToken: string;
}
export declare enum AuthType {
    COOKIE = "COOKIE",
    CALLBACK_TOKEN = "CALLBACK_TOKEN"
}
export declare enum AgentType {
    Custom = "Custom",
    Contacts = "Contacts",
    Telephone = "Telephone",
    Schedule = "Schedule",
    Customer = "Customer",
    Attendance = "Attendance",
    Approval = "Approval",
    Hongbao = "Hongbao"
}
export declare enum AuthFailResult {
    UserRejectQrCode = "UserRejectQrCode",
    QueryUserIdFail = "QueryUserIdFail",
    QueryUserInfoFail = "QueryUserInfoFail",
    UserInactive = "UserInactive"
}
export interface Result {
    errcode: number;
    errmsg: string;
}
export interface WechatWorkData {
    [key: string]: any;
}
export interface BaseConfig {
    corpId: string;
    agentId?: string;
    agentSecret?: string;
    contactsSecret?: string;
    telephoneSecret?: string;
    scheduleSecret?: string;
    customerSecret?: string;
    attendanceAgentId?: string;
    attendanceSecret?: string;
    approvalAgentId?: string;
    approvalSecret?: string;
    hongbaoAgentId?: string;
    hongbaoSecret?: string;
}
export interface AuthConfig {
    type?: AuthType;
    returnDomainName: string;
    loginPath?: string;
    logoutPath?: string;
    loginSuccessPath?: string;
    loginFailPath?: string;
    noRedirectPaths?: string[];
    tokenName?: string;
    tokenExpires?: number;
    jwtSecret: string;
}
export declare class WechatWorkConfig {
    baseConfig: BaseConfig;
    authConfig?: AuthConfig;
}
export interface WechatWorkConfigFactory {
    createWechatWorkConfig(): Promise<WechatWorkConfig> | WechatWorkConfig;
}
export interface WechatWorkAsyncConfig extends Pick<ModuleMetadata, 'imports'> {
    useExisting?: Type<WechatWorkConfigFactory>;
    useClass?: Type<WechatWorkConfigFactory>;
    useFactory?: (...args: any[]) => Promise<WechatWorkConfig> | WechatWorkConfig;
    inject?: any[];
}
