"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var WechatWorkModule_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.WechatWorkModule = void 0;
const common_1 = require("@nestjs/common");
const services_1 = require("./services");
const middleware_1 = require("./middleware");
const interfaces_1 = require("./interfaces");
const constants_1 = require("./constants");
const wechat_work_providers_1 = require("./wechat-work.providers");
let WechatWorkModule = WechatWorkModule_1 = class WechatWorkModule {
    constructor(config) {
        this.config = config;
    }
    static register(config) {
        return {
            module: WechatWorkModule_1,
            providers: wechat_work_providers_1.createWechatWorkConfigProvider(config),
        };
    }
    static registerAsync(config) {
        return {
            module: WechatWorkModule_1,
            imports: config.imports || [],
            providers: this.createAsyncProviders(config),
        };
    }
    static createAsyncProviders(config) {
        if (config.useExisting || config.useFactory) {
            return [this.createAsyncConfigProvider(config)];
        }
        return [
            this.createAsyncConfigProvider(config),
            {
                provide: config.useClass,
                useClass: config.useClass,
            },
        ];
    }
    static createAsyncConfigProvider(config) {
        if (config.useFactory) {
            return {
                provide: constants_1.WECHAT_WORK_MODULE_CONFIG,
                useFactory: config.useFactory,
                inject: config.inject || [],
            };
        }
        return {
            provide: constants_1.WECHAT_WORK_MODULE_CONFIG,
            useFactory: (configFactory) => __awaiter(this, void 0, void 0, function* () { return yield configFactory.createWechatWorkConfig(); }),
            inject: [config.useExisting || config.useClass],
        };
    }
    configure(consumer) {
        return __awaiter(this, void 0, void 0, function* () {
            consumer.apply(middleware_1.WechatWorkAuthMiddleware).forRoutes('*');
        });
    }
};
WechatWorkModule = WechatWorkModule_1 = __decorate([
    common_1.Global(),
    common_1.Module({
        imports: [common_1.HttpModule],
        providers: [services_1.WechatWorkBaseService, services_1.WechatWorkContactsService, services_1.WechatWorkAuthService, interfaces_1.WechatWorkConfig],
        exports: [services_1.WechatWorkBaseService, services_1.WechatWorkContactsService, services_1.WechatWorkAuthService, interfaces_1.WechatWorkConfig],
    }),
    __metadata("design:paramtypes", [interfaces_1.WechatWorkConfig])
], WechatWorkModule);
exports.WechatWorkModule = WechatWorkModule;
